# This program is free software; you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation; either version 2 of the License, or
#     (at your option) any later version.
# 
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
# 
#     You should have received a copy of the GNU General Public License
#     along with this program; if not, write to the Free Software
#     Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


require 'mainwindow.rb'
require 'ewimp.rb'
require 'videotools.rb'

class MainImpl < Form1
  
    signals 'startEncoding(const QString&)','videoInfo(const QString&)','audioInfo(const QString&)','dpgInfo(const QString&)','siError(const QString&)'
    slots 'pushButton2_clicked()','pushButton4_clicked()','pushButton4_2_clicked()','checkBox1_clicked()','timeout()'

    def timeout
	sleep 0.01
    end


    def checkBox1_clicked()
	if checkBox1.isChecked()
		lineEdit3.setDisabled(true)
	else
		lineEdit3.setEnabled(true)
	end
    end
    def pushButton4_clicked()
	
	vt = VideoTools.new
	ew = EwImp.new
	ew.show()
	#connect slots/signals
	Qt::Object.connect( self, SIGNAL( "startEncoding(const QString&)" ),ew, SLOT( "sstartEncoding(const QString&)" ) )
	Qt::Object.connect( self, SIGNAL( "videoInfo(const QString&)" ),ew, SLOT( "svideoInfo(const QString&)" ) )
	Qt::Object.connect( self, SIGNAL( "audioInfo(const QString&)" ),ew, SLOT( "saudioInfo(const QString&)" ) )
	Qt::Object.connect( self, SIGNAL( "dpgInfo(const QString&)" ),ew, SLOT( "sdpgInfo(const QString&)" ) )
	Qt::Object.connect( self, SIGNAL( "siError(const QString&)" ),ew, SLOT( "sError(const QString&)" ) )

	Qt::Object.connect( vt, SIGNAL( "startEncoding(const QString&)" ),ew, SLOT( "sstartEncoding(const QString&)" ) )
	Qt::Object.connect( vt, SIGNAL( "videoInfo(const QString&)" ),ew, SLOT( "svideoInfo(const QString&)" ) )
	Qt::Object.connect( vt, SIGNAL( "audioInfo(const QString&)" ),ew, SLOT( "saudioInfo(const QString&)" ) )
	Qt::Object.connect( vt, SIGNAL( "dpgInfo(const QString&)" ),ew, SLOT( "sdpgInfo(const QString&)" ) )
	Qt::Object.connect( vt, SIGNAL( "siError(const QString&)" ),ew, SLOT( "sError(const QString&)" ) )
	Qt::Object.connect( vt, SIGNAL( "sivideoProgressBar(int)" ),ew, SLOT( "svideoProgressBar(int)" ) )
	Qt::Object.connect( vt, SIGNAL( "siaudioProgressBar(int)" ),ew, SLOT( "saudioProgressBar(int)" ) )
	Qt::Object.connect( vt, SIGNAL( "refresh()" ),self, SLOT( "repaint()" ) )
			
	self.setDisabled(true)
	numvideos = listBox1.count()
	if numvideos>0
		
		emit siError(Time.now.to_s+":Start encoding "+numvideos.to_s+" files")
		aux=0
		audiomp2 = false

		if (comboBox5_2.currentText() == "MP2")
			audiomp2 = true
		end

		th = Thread.start{		
			numvideos.times do
				ew.clearAll()
				emit siError("Encoding file "+(aux+1).to_s+" of "+numvideos.to_s)
				ivtime = vt.vidinfo(listBox1.text(aux))
				width = lineEdit3.text().to_i
				if checkBox1.isChecked()
					width = ((vt.ivh.to_i * lineEdit2.text().to_i) / vt.ivw.to_i )
					lineEdit3.setText(width.to_s)
				end
				vt.setvalues(comboBox1.currentText(), comboBox2.currentText(), comboBox6_2.currentText(), comboBox5_2.currentText(), lineEdit2.text(),width.to_s, comboBox5.currentText(), comboBox6.currentText(), comboBox7.currentItem())
				
				if vt.encodevideo(listBox1.text(aux)) == 1
					return
				end
				if audiomp2 == true

					if vt.encodeAudioMP2(listBox1.text(aux)) == 1
						return	
					end
					vt.createHeaderMP2(ivtime)
				else
					if vt.encodeAudioGSM(listBox1.text(aux)) == 1
						return	
					end
					vt.createHeaderGSM(ivtime)
				end
				vt.concatDpg(listBox1.text(aux))
 				aux+=1			
			end
			vt.cleanTemp()
			emit siError(Time.now.to_s+":End encoding "+numvideos.to_s+" files")
			ew.pushButton5.setEnabled(true)
			self.setEnabled(true)	
		
		}
		
		
		
					
	else
		Qt::MessageBox::information(self, "DpgEncoder", "There are no file(s)!")
		self.setEnabled(true)
	end
	
    end
    def pushButton4_2_clicked()
	listBox1.removeItem(listBox1.currentItem())
    end
    def pushButton2_clicked()
	fn = Qt::FileDialog.getOpenFileNames( nil, nil, self)
	if !fn.nil?
	    aux=0
	    numf=fn.size()
	    vaux = VideoTools.new
	    numf.times do
		if vaux.vidinfo(fn[aux]) != -1
	    		listBox1.insertItem(fn[aux], 0)
		else
			Qt::MessageBox::information(self, "DPG Encoder", "Unable to encode:"+fn[aux])
		end
	    	aux+=1
	    end
        else
            statusBar().message( tr("Loading aborted"), 2000 )
        end
    end

    def initialize(*k)
        super(*k)
	timer = Qt::Timer.new( self )
	connect( timer, SIGNAL( 'timeout()' ), SLOT( 'timeout()' ) )
	timer.start( 0 )
	 Qt::Object.connect( @pushButton2, SIGNAL( "clicked()" ),self, SLOT( "pushButton2_clicked()" ) )
	comboBox2.setCurrentItem(7);
	Qt::Object.connect( @pushButton4, SIGNAL( "clicked()" ),self, SLOT( "pushButton4_clicked()" ) )
	Qt::Object.connect( @pushButton4_2, SIGNAL( "clicked()" ),self, SLOT( "pushButton4_2_clicked()" ) )
	
	Qt::Object.connect( @checkBox1, SIGNAL( "clicked()" ),self, SLOT( "checkBox1_clicked()" ) )
	checkBox1_clicked()
	aux = 0;
	String aux2 = 64
	26.times do
		comboBox5.insertItem( aux2.to_s, aux)
		aux2+=16
	end

    comboBox6.insertItem("Auto", 0)
    aux=1;
    24.times do
		comboBox6.insertItem( aux.to_s, aux)
		aux+=1
	end

	comboBox5.setCurrentItem(11)
	comboBox6.setCurrentItem(0)
	comboBox1.setCurrentItem(1)
	comboBox5_2.setCurrentItem(1)
	comboBox6_2.setCurrentItem(1)
	comboBox7.setCurrentItem(1)




    end
end
